/**********************************************************************
*                                                                     *
*   Associative Coder of Buyanovsky (ACB)                             *
*                                                                     *
* acb.h                                                               *
*                                                                     *
* Implemented by Martin Decky, distributed under GNU GPL              *
*                                                                     *
**********************************************************************/

#ifndef __ACB_H__
#define __ACB_H__

#include <iostream>

#include "vocabulary.h"
#include "triplet.h"

namespace ACB {

	class Encoder {
		public:
			Encoder(Vocabulary & _voc, TripletEncoder & _trip, std::istream & _ins);
			virtual ~Encoder();
			
			virtual const Encoder & operator+=(const size_t cnt);
		private:
			TripletEncoder * trip;
			Vocabulary * voc;
			std::istream * ins;
	};
	
	class Decoder {
		public:
			Decoder(Vocabulary & _voc, TripletDecoder & _trip, std::ostream & _outs);
			virtual ~Decoder();
			
			virtual const Decoder & operator+=(const size_t cnt);
		private:
			TripletDecoder * trip;
			Vocabulary * voc;
			std::ostream * outs;
	};

}

#endif /* __ACB_H__ */
